# `@springtree/eva-services-core`

The core services for the EVA platform.
These services will be required for all client applications.
They can be used together with the `EvaService` class provided by `@springtree/eva-sdk-core-service`.

## Usage

```typescript
import { createServiceDefinition, Core } from '@springtree/eva-services-core';
import { EvaService } from '@springtree/eva-sdk-core-service';

const endpoint = await bootstrapEndpoint({ uri: 'https://eva-tst.newblack.io' });
const service = new EvaService<Core.ListApplications>(
  createServiceDefinition(Core.ListApplications),
  endpoint,
);

// Set the request payload before the call
// The data.request property is typed according to the type of service
// instance you created
//
service.data.request = { ... };

try {
  const result = await service.call();
} catch (error) {
  console.error(error);
}
```
