declare module EVA.Kafka {

  /**
   * Export Kafka message history to CSV. Only accessible by NewBlack
   */
  export interface KafkaHistoryExportRequest {
    /**
     * Optional configuration ID to use as a filter
     * Entity type: EventExportConfiguration
     */
    EventExportConfigurationID?: number;
    /**
     * Optional specific message identifiers to filter
     */
    Identifiers?: string[];
    /**
     * Maximum number of messages to export
     */
    MaxMessages?: number;
    /**
     * Group to export from (when no event export config is specified)
     * @default Events
     */
    MessageGroup?: EVA.Core.MessageGroups;
  }

}
