declare module EVA.PDF {

  export namespace Errors {
    export const enum MergePdfBlobs {
      /**
       * Too many blobs
       */
      TooManyBlobs = 'MergePdfBlobs:TooManyBlobs'
    }

    export const enum BlobMerger {
      /**
       * Blob {blobID:string} has invalid mime type {mimeType:string}
       */
      InvalidMimeType = 'BlobMerger:InvalidMimeType',
      /**
       * Merging PDFs failed
       */
      MergeFailed = 'BlobMerger:MergeFailed'
    }

  }


  /**
   * Merges blobs into one PDF
   */
  export interface MergePdfBlobs {
    /**
     * Can be used for standard blobs - for secure blobs, use `BlobUrls` instead. Limited to 100 entries.
     * Entity type: Blob
     */
    Blobs?: string[];
    /**
     * Can be used for both standard- and secured blobs - must match environment assets URL. Limited to 100 entries.
     */
    BlobUrls?: string[];
  }

}
