declare module EVA.Payment.Buckaroo {

  export interface BuckarooPaymentMethodPayData {
    BillingTitle: string;
    BillingGender: BuckarooGender;
    BillingInitials: string;
    BillingLastName: string;
    BillingBirthDate: string;
    BillingStreet: string;
    BillingHouseNumber: number;
    BillingPostalCode: string;
    BillingCity: string;
    BillingCountry: string;
    BillingEmail: string;
    BillingPhoneNumber: string;
    BillingLanguage: string;
    AddressesDiffer: boolean;
    ShippingTitle: string;
    ShippingGender: BuckarooGender;
    ShippingInitials: string;
    ShippingLastName: string;
    ShippingBirthDate: string;
    ShippingStreet: string;
    ShippingHouseNumber: number;
    ShippingPostalCode: string;
    ShippingCity: string;
    ShippingCountryCode: string;
    ShippingEmail: string;
    ShippingPhoneNumber: string;
    ShippingLanguage: string;
    B2B: boolean;
    CompanyCOCRegistration: string;
    CompanyName: string;
    CostCentre: string;
    Department: string;
    EstablishmentNumber: string;
    VatNumber: string;
    Accept: boolean;
    ShippingCosts: number;
    Articles: BuckarooArticle[];
    FashionChequeCardNumber: string;
    Issuer: string;
    BuyerEmail: string;
    PageStyle: string;
    ProductName: string;
    MerchantSendsEmail: boolean;
    ExpirationDate?: string;
    PaymentMethodsAllowed: string;
    CustomerFirstName: string;
    CustomerLastName: string;
    CustomerGender: BuckarooCustomerGender;
    CustomerCountry: string;
    SendMail: boolean;
    CustomerEmail: string;
    DateDue: string;
    IntersolveCardnumber: string;
    IntersolvePIN: string;
    ReturnUrl: string;
    GatewayID: string;
  }

  export const enum BuckarooGender {
    Male = 1,
    Female = 2
  }

  export interface BuckarooArticle {
    ArticleDescription: string;
    ArticleId: string;
    ArticleQuantity: number;
    ArticleUnitprice: number;
    ArticleVatcategory: BuckarooArticleVatcategory;
  }

  export const enum BuckarooArticleVatcategory {
    HighRate = 1,
    LowRate = 2,
    ZeroRate = 3,
    NullRate = 4,
    MiddleRate = 5
  }

  export const enum BuckarooCustomerGender {
    Unknown = 0,
    Male = 1,
    Female = 2,
    NotApplicable = 9
  }

  export interface BuckarooPaymentMethodPayResult {
    PayLink: string;
    BIC: string;
    IBAN: string;
    AccountHolderName: string;
    BankAccount: string;
    AccountHolderCity: string;
    AccountHolderCountry: string;
    PaymentReference: string;
    RedirectUrl: string;
  }

}
