declare module EVA.Payment.Saferpay {

  export namespace Errors {
    export const enum Saferpay {
      /**
       * Cannot capture payment. Missing transaction id
       */
      MissingTransactionIdForCapture = 'Saferpay:MissingTransactionIdForCapture',
      /**
       * This payment is already captured
       */
      PaymentAlreadyCaptured = 'Saferpay:PaymentAlreadyCaptured',
      /**
       * Failed to capture payment. {0:string}
       */
      SaferpayCaptureFailed = 'Saferpay:SaferpayCaptureFailed',
      /**
       * Failed to refund payment. {0:string}
       */
      SaferpayRefundFailed = 'Saferpay:SaferpayRefundFailed',
      /**
       * Failed to initialize payment. {0:string}
       */
      SaferpayInitializeFailed = 'Saferpay:SaferpayInitializeFailed'
    }

  }


  export interface SaferpayPaymentMethodRequestProperties {
    ReturnUrlSuccess?: string;
    ReturnUrlFail?: string;
  }

  export interface SaferpayPaymentMethodResponseProperties {
    RedirectUrl?: string;
  }

}
