declare module EVA.ShelfManagement {

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface ExportShelfTemplate {
    /**
     * Entity type: Shelf
     */
    ShelfIDs: number[];
  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface ImportShelfTemplate {
    Data: string;
  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface UpdateOrganizationUnitDistributionTree {
    Tree?: TreeNode;
  }

  export interface TreeNode {
    Fraction?: number;
    /**
     * Entity type: OrganizationUnit
     */
    OrganizationUnitIDs: number[];
    OrganizationUnitTypeID?: number;
    Negation: boolean;
    Nodes: TreeNode[];
  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface GetOrganizationUnitDistributionTree {
  }

  export interface GetOrganizationUnitDistributionTreeResponse {
    Tree: TreeNode;
    Error?: EVA.Core.ServiceError;
    Metadata?: EVA.Core.ResponseMessageMetadata;
  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface GetOrganizationUnitShelfByID {
    /**
     * Entity type: OrganizationUnitShelf
     */
    ID: number;
  }

  export interface GetOrganizationUnitShelfByIDResponse {
    ID: number;
    ShelfID: number;
    OrganizationUnitID?: number;
    OrganizationUnitTypeID?: number;
    Error?: EVA.Core.ServiceError;
    Metadata?: EVA.Core.ResponseMessageMetadata;
  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface CreateOrganizationUnitShelf {
    /**
     * Entity type: Shelf
     */
    ShelfID: number;
    /**
     * Entity type: OrganizationUnit
     */
    OrganizationUnitID?: number;
    OrganizationUnitTypeID?: number;
  }

  export interface CreateOrganizationUnitShelfResponse {
    ID: number;
    Error?: EVA.Core.ServiceError;
    Metadata?: EVA.Core.ResponseMessageMetadata;
  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface UpdateOrganizationUnitShelf {
    /**
     * Entity type: OrganizationUnitShelf
     */
    ID: number;
    /**
     * Entity type: Shelf
     */
    ShelfID: number;
    /**
     * Entity type: OrganizationUnit
     */
    OrganizationUnitID?: number;
    OrganizationUnitTypeID?: number;
  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface DeleteOrganizationUnitShelf {
    /**
     * Entity type: OrganizationUnitShelf
     */
    ID: number;
  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface ListOrganizationUnitShelves {
    PageConfig?: EVA.Core.PageConfig<{ [key:string]: string }>;
  }

  export interface ListOrganizationUnitShelvesResponse {
    Result?: EVA.Core.PagedResult<ListOrganizationUnitShelvesResponse.OrganizationUnitShelfDto>;
    Error?: EVA.Core.ServiceError;
    Metadata?: EVA.Core.ResponseMessageMetadata;
  }

  export namespace ListOrganizationUnitShelvesResponse {
    export interface OrganizationUnitShelfDto {
      ID: number;
      ShelfID: number;
      Shelf: ListOrganizationUnitShelvesResponse.ShelfDto;
      OrganizationUnitID?: number;
      OrganizationUnit: EVA.Core.OrganizationUnitDto;
      OrganizationUnitTypeID?: number;
    }

    export interface ShelfDto {
      /**
       * Entity type: Shelf
       */
      ID: number;
      Name: string;
      Description: string;
      StartDateTime: string;
      EndDateTime?: string;
      /**
       * Entity type: ShelfType
       */
      TypeID: number;
      Type: EVA.Core.EnumDto;
      Height?: number;
      Width?: number;
      Depth?: number;
    }

  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface GetProductRestrictionByID {
    /**
     * Entity type: ProductRestriction
     */
    ID: number;
  }

  export interface GetProductRestrictionByIDResponse {
    /**
     * Entity type: ProductRestriction
     */
    ID: number;
    /**
     * Entity type: Product
     */
    ProductID: number;
    /**
     * Entity type: OrganizationUnit
     */
    OrganizationUnitID?: number;
    OrganizationUnitTypeID?: number;
    MaximumReplenismentQuantity?: number;
    MaximumStockQuantity?: number;
    Error?: EVA.Core.ServiceError;
    Metadata?: EVA.Core.ResponseMessageMetadata;
  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface CreateProductRestriction {
    /**
     * Entity type: Product
     */
    ProductID: number;
    /**
     * Entity type: OrganizationUnit
     */
    OrganizationUnitID?: number;
    OrganizationUnitTypeID?: number;
    MaximumReplenismentQuantity?: number;
    MaximumStockQuantity?: number;
  }

  export interface CreateProductRestrictionResponse {
    /**
     * Entity type: ProductRestriction
     */
    ID: number;
    Error?: EVA.Core.ServiceError;
    Metadata?: EVA.Core.ResponseMessageMetadata;
  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface UpdateProductRestriction {
    /**
     * Entity type: ProductRestriction
     */
    ID: number;
    /**
     * Entity type: Product
     */
    ProductID: number;
    /**
     * Entity type: OrganizationUnit
     */
    OrganizationUnitID?: number;
    OrganizationUnitTypeID?: number;
    MaximumReplenismentQuantity?: number;
    MaximumStockQuantity?: number;
  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface DeleteProductRestriction {
    /**
     * Entity type: ProductRestriction
     */
    ID: number;
  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface ListProductRestrictions {
    PageConfig?: EVA.Core.PageConfig<{ [key:string]: string }>;
  }

  export interface ListProductRestrictionsResponse {
    Result?: EVA.Core.PagedResult<ListProductRestrictionsResponse.ProductRestrictionDto>;
    Error?: EVA.Core.ServiceError;
    Metadata?: EVA.Core.ResponseMessageMetadata;
  }

  export namespace ListProductRestrictionsResponse {
    export interface ProductRestrictionDto {
      ID: number;
      ProductID: number;
      Product: ListProductRestrictionsResponse.ProductDto;
      OrganizationUnitID?: number;
      OrganizationUnitTypeID?: number;
      MaximumReplenismentQuantity?: number;
      MaximumStockQuantity?: number;
    }

    export interface ProductDto {
      BackendID: string;
      DisplayValue: string;
    }

  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface GetShelfBlobByID {
    /**
     * Entity type: ShelfBlob
     */
    ID: number;
  }

  export interface GetShelfBlobByIDResponse {
    /**
     * Entity type: ShelfBlob
     */
    ID: number;
    /**
     * Entity type: Shelf
     */
    ShelfID: number;
    BlobID: string;
    Error?: EVA.Core.ServiceError;
    Metadata?: EVA.Core.ResponseMessageMetadata;
  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface CreateShelfBlob {
    /**
     * Entity type: Shelf
     */
    ShelfID: number;
    BlobID: string;
  }

  export interface CreateShelfBlobResponse {
    /**
     * Entity type: ShelfBlob
     */
    ID: number;
    Error?: EVA.Core.ServiceError;
    Metadata?: EVA.Core.ResponseMessageMetadata;
  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface UpdateShelfBlob {
    /**
     * Entity type: ShelfBlob
     */
    ID: number;
    /**
     * Entity type: Shelf
     */
    ShelfID: number;
    BlobID: string;
  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface DeleteShelfBlob {
    /**
     * Entity type: ShelfBlob
     */
    ID: number;
  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface ListShelfBlobs {
    PageConfig?: EVA.Core.PageConfig<{ [key:string]: string }>;
  }

  export interface ListShelfBlobsResponse {
    Result?: EVA.Core.PagedResult<ListShelfBlobsResponse.ShelfBlobDto>;
    Error?: EVA.Core.ServiceError;
    Metadata?: EVA.Core.ResponseMessageMetadata;
  }

  export namespace ListShelfBlobsResponse {
    export interface ShelfBlobDto {
      ID: number;
      ShelfID: number;
      BlobID: string;
    }

  }

  /**
   * @deprecated Feature not supported anymore.
   * Get a Shelf by ID
   */
  export interface GetShelfByID {
    /**
     * Entity type: Shelf
     */
    ID: number;
  }

  export interface GetShelfByIDResponse {
    ID: number;
    Name: string;
    Description: string;
    StartDateTime: string;
    EndDateTime?: string;
    StockLabelID?: number;
    TypeID: number;
    Height?: number;
    Width?: number;
    Depth?: number;
    Error?: EVA.Core.ServiceError;
    Metadata?: EVA.Core.ResponseMessageMetadata;
  }

  /**
   * @deprecated Feature not supported anymore.
   * Create a new Shelf
   */
  export interface CreateShelf {
    Name: string;
    Description?: string;
    StartDateTime: string;
    EndDateTime?: string;
    /**
     * Entity type: StockLabel
     */
    StockLabelID?: number;
    /**
     * Entity type: ShelfType
     */
    TypeID: number;
    Height?: number;
    Width?: number;
    Depth?: number;
  }

  export interface CreateShelfResponse {
    /**
     * Entity type: Shelf
     */
    ID: number;
    Error?: EVA.Core.ServiceError;
    Metadata?: EVA.Core.ResponseMessageMetadata;
  }

  /**
   * @deprecated Feature not supported anymore.
   * Update a Shelf
   */
  export interface UpdateShelf {
    /**
     * Entity type: Shelf
     */
    ID: number;
    Name: string;
    Description?: string;
    StartDateTime: string;
    EndDateTime?: string;
    /**
     * Entity type: StockLabel
     */
    StockLabelID?: number;
    /**
     * Entity type: ShelfType
     */
    TypeID: number;
    Height?: number;
    Width?: number;
    Depth?: number;
  }

  /**
   * @deprecated Feature not supported anymore.
   * Delete a Shelf
   */
  export interface DeleteShelf {
    /**
     * Entity type: Shelf
     */
    ID: number;
  }

  /**
   * @deprecated Feature not supported anymore.
   * List Shelves
   */
  export interface ListShelves {
    PageConfig?: EVA.Core.PageConfig<ListShelvesFilter>;
  }

  export interface ListShelvesFilter {
    Name: string;
    /**
     * Entity type: ShelfType
     */
    TypeID?: number;
    StartDateTime?: string;
    EndDateTime?: string;
    /**
     * Entity type: Product
     */
    ProductID?: number;
  }

  export interface ListShelvesResponse {
    Result?: EVA.Core.PagedResult<ListShelvesResponse.ShelfDto>;
    Error?: EVA.Core.ServiceError;
    Metadata?: EVA.Core.ResponseMessageMetadata;
  }

  export namespace ListShelvesResponse {
    export interface ShelfDto {
      /**
       * Entity type: Shelf
       */
      ID: number;
      Name: string;
      Description: string;
      StartDateTime: string;
      EndDateTime?: string;
      /**
       * Entity type: StockLabel
       */
      StockLabelID?: number;
      /**
       * Entity type: ShelfType
       */
      TypeID: number;
      Type: EVA.Core.EnumDto;
      Height?: number;
      Width?: number;
      Depth?: number;
    }

  }

  /**
   * @deprecated Feature not supported anymore.
   * Duplicate a Shelf
   * 
   * All properties will be copied except for the Name, StartDateTime, EndDateTime
   * The ShelfLocations will also be duplicated
   */
  export interface DuplicateShelf {
    /**
     * Entity type: Shelf
     */
    ShelfID: number;
    Name: string;
    StartDateTime: string;
    EndDateTime?: string;
  }

  export interface DuplicateShelfResponse {
    ID: number;
    Error?: EVA.Core.ServiceError;
    Metadata?: EVA.Core.ResponseMessageMetadata;
  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface GetShelfLocationBlobByID {
    /**
     * Entity type: ShelfLocationBlob
     */
    ID: number;
  }

  export interface GetShelfLocationBlobByIDResponse {
    ID: number;
    ShelfLocationID: number;
    BlobID: string;
    Error?: EVA.Core.ServiceError;
    Metadata?: EVA.Core.ResponseMessageMetadata;
  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface CreateShelfLocationBlob {
    /**
     * Entity type: ShelfLocation
     */
    ShelfLocationID: number;
    BlobID: string;
  }

  export interface CreateShelfLocationBlobResponse {
    ID: number;
    Error?: EVA.Core.ServiceError;
    Metadata?: EVA.Core.ResponseMessageMetadata;
  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface UpdateShelfLocationBlob {
    /**
     * Entity type: ShelfLocationBlob
     */
    ID: number;
    /**
     * Entity type: ShelfLocation
     */
    ShelfLocationID: number;
    BlobID: string;
  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface DeleteShelfLocationBlob {
    /**
     * Entity type: ShelfLocationBlob
     */
    ID: number;
  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface ListShelfLocationBlobs {
    PageConfig?: EVA.Core.PageConfig<{ [key:string]: string }>;
  }

  export interface ListShelfLocationBlobsResponse {
    Result?: EVA.Core.PagedResult<ListShelfLocationBlobsResponse.ShelfLocationBlobDto>;
    Error?: EVA.Core.ServiceError;
    Metadata?: EVA.Core.ResponseMessageMetadata;
  }

  export namespace ListShelfLocationBlobsResponse {
    export interface ShelfLocationBlobDto {
      ID: number;
      ShelfLocationID: number;
      BlobID: string;
    }

  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface GetShelfLocationByID {
    /**
     * Entity type: ShelfLocation
     */
    ID: number;
  }

  export interface GetShelfLocationByIDResponse {
    ID: number;
    ShelfID: number;
    ParentID?: number;
    TemplateID: number;
    Name: string;
    Error?: EVA.Core.ServiceError;
    Metadata?: EVA.Core.ResponseMessageMetadata;
  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface CreateShelfLocation {
    /**
     * Entity type: Shelf
     */
    ShelfID: number;
    /**
     * Entity type: ShelfLocation
     */
    ParentID?: number;
    /**
     * Entity type: ShelfLocationTemplate
     */
    TemplateID: number;
    Name: string;
  }

  export interface CreateShelfLocationResponse {
    /**
     * Entity type: ShelfLocation
     */
    ID: number;
    Error?: EVA.Core.ServiceError;
    Metadata?: EVA.Core.ResponseMessageMetadata;
  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface UpdateShelfLocation {
    /**
     * Entity type: ShelfLocation
     */
    ID: number;
    /**
     * Entity type: ShelfLocation
     */
    ParentID?: number;
    /**
     * Entity type: ShelfLocationTemplate
     */
    TemplateID: number;
    Name: string;
  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface DeleteShelfLocation {
    /**
     * Entity type: ShelfLocation
     */
    ID: number;
  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface ListShelfLocations {
    PageConfig?: EVA.Core.PageConfig<{ [key:string]: string }>;
  }

  export interface ListShelfLocationsResponse {
    Result?: EVA.Core.PagedResult<ListShelfLocationsResponse.ShelfLocationDto>;
    Error?: EVA.Core.ServiceError;
    Metadata?: EVA.Core.ResponseMessageMetadata;
  }

  export namespace ListShelfLocationsResponse {
    export interface ShelfLocationDto {
      /**
       * Entity type: ShelfLocation
       */
      ID: number;
      /**
       * Entity type: Shelf
       */
      ShelfID: number;
      /**
       * Entity type: ShelfLocation
       */
      ParentID?: number;
      /**
       * Entity type: ShelfLocationTemplate
       */
      TemplateID: number;
      Name: string;
    }

  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface GetShelfLocationProductByID {
    /**
     * Entity type: ShelfLocationProduct
     */
    ID: number;
  }

  export interface GetShelfLocationProductByIDResponse {
    ID: number;
    ShelfLocationID: number;
    ProductID: number;
    MinimumQuantity: number;
    MaximumQuantity: number;
    Error?: EVA.Core.ServiceError;
    Metadata?: EVA.Core.ResponseMessageMetadata;
  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface CreateShelfLocationProduct {
    /**
     * Entity type: ShelfLocation
     */
    ShelfLocationID: number;
    /**
     * Entity type: Product
     */
    ProductID: number;
    MinimumQuantity: number;
    MaximumQuantity: number;
  }

  export interface CreateShelfLocationProductResponse {
    /**
     * Entity type: ShelfLocationProduct
     */
    ID: number;
    Error?: EVA.Core.ServiceError;
    Metadata?: EVA.Core.ResponseMessageMetadata;
  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface UpdateShelfLocationProduct {
    /**
     * Entity type: ShelfLocationProduct
     */
    ID: number;
    MinimumQuantity: number;
    MaximumQuantity: number;
  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface DeleteShelfLocationProduct {
    /**
     * Entity type: ShelfLocationProduct
     */
    ID: number;
  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface ListShelfLocationProducts {
    PageConfig?: EVA.Core.PageConfig<ListShelfLocationProductsFilter>;
  }

  export interface ListShelfLocationProductsFilter {
    ProductQuery: string;
    /**
     * Entity type: ShelfLocation
     */
    ShelfLocationID?: number;
    /**
     * Entity type: Product
     */
    ProductID?: number;
    MinimumQuantity?: number;
    MaximumQuantity?: number;
  }

  export interface ListShelfLocationProductsResponse {
    Result?: EVA.Core.PagedResult<ListShelfLocationProductsResponse.ShelfLocationProductDto>;
    Error?: EVA.Core.ServiceError;
    Metadata?: EVA.Core.ResponseMessageMetadata;
  }

  export namespace ListShelfLocationProductsResponse {
    export interface ShelfLocationProductDto {
      /**
       * Entity type: ShelfLocationProduct
       */
      ID: number;
      /**
       * Entity type: ShelfLocation
       */
      ShelfLocationID: number;
      ShelfLocation: ListShelfLocationProductsResponse.ShelfLocationDto;
      /**
       * Entity type: Product
       */
      ProductID: number;
      Product: ListShelfLocationProductsResponse.ShelfProductDto;
      MinimumQuantity: number;
      MaximumQuantity: number;
    }

    export interface ShelfProductDto {
      BackendID: string;
      CustomID: string;
      DisplayValue: string;
      DisplayPrice?: number;
    }

    export interface ShelfLocationDto {
      Name: string;
      /**
       * Entity type: Shelf
       */
      ShelfID: number;
      Shelf: ListShelfLocationProductsResponse.ShelfDto;
    }

    export interface ShelfDto {
      Name: string;
    }

  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface UploadShelfLocationProducts {
    /**
     * Entity type: ShelfLocation
     */
    ShelfLocationID: number;
    Data: string;
  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface DownloadShelfLocationProducts {
    /**
     * Entity type: ShelfLocation
     */
    ShelfLocationID: number;
  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface CreateShelfLocationProducts {
    /**
     * Entity type: ShelfLocation
     */
    ShelfLocationID: number;
    Products: CreateShelfLocationProducts.ProductDto[];
  }

  export namespace CreateShelfLocationProducts {
    export interface ProductDto {
      /**
       * Entity type: Product
       */
      ProductID: number;
      MinimumQuantity: number;
      MaximumQuantity: number;
    }

  }

  export interface CreateShelfLocationProductsResponse {
    IDs: number[];
    Error?: EVA.Core.ServiceError;
    Metadata?: EVA.Core.ResponseMessageMetadata;
  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface GetShelfLocationTemplateByID {
    /**
     * Entity type: ShelfLocationTemplate
     */
    ID: number;
  }

  export interface GetShelfLocationTemplateByIDResponse {
    ID: number;
    TypeID: number;
    Name: string;
    ProductLimit?: number;
    Height?: number;
    Width?: number;
    Depth?: number;
    Error?: EVA.Core.ServiceError;
    Metadata?: EVA.Core.ResponseMessageMetadata;
  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface CreateShelfLocationTemplate {
    /**
     * Entity type: ShelfLocationTemplateType
     */
    TypeID: number;
    Name: string;
    ProductLimit?: number;
    Height?: number;
    Width?: number;
    Depth?: number;
  }

  export interface CreateShelfLocationTemplateResponse {
    /**
     * Entity type: ShelfLocationTemplate
     */
    ID: number;
    Error?: EVA.Core.ServiceError;
    Metadata?: EVA.Core.ResponseMessageMetadata;
  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface UpdateShelfLocationTemplate {
    /**
     * Entity type: ShelfLocationTemplate
     */
    ID: number;
    /**
     * Entity type: ShelfLocationTemplateType
     */
    TypeID: number;
    Name: string;
    ProductLimit?: number;
    Height?: number;
    Width?: number;
    Depth?: number;
  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface DeleteShelfLocationTemplate {
    /**
     * Entity type: ShelfLocationTemplate
     */
    ID: number;
  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface ListShelfLocationTemplates {
    PageConfig?: EVA.Core.PageConfig<{ [key:string]: string }>;
  }

  export interface ListShelfLocationTemplatesResponse {
    Result?: EVA.Core.PagedResult<ListShelfLocationTemplatesResponse.ShelfLocationTemplateDto>;
    Error?: EVA.Core.ServiceError;
    Metadata?: EVA.Core.ResponseMessageMetadata;
  }

  export namespace ListShelfLocationTemplatesResponse {
    export interface ShelfLocationTemplateDto {
      /**
       * Entity type: ShelfLocationTemplate
       */
      ID: number;
      /**
       * Entity type: ShelfLocationTemplateType
       */
      TypeID: number;
      Name: string;
      ProductLimit?: number;
      Height?: number;
      Width?: number;
      Depth?: number;
    }

  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface GetShelfLocationTemplateTypeByID {
    /**
     * Entity type: ShelfLocationTemplateType
     */
    ID: number;
  }

  export interface GetShelfLocationTemplateTypeByIDResponse {
    ID: number;
    Name: string;
    Description: string;
    Error?: EVA.Core.ServiceError;
    Metadata?: EVA.Core.ResponseMessageMetadata;
  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface CreateShelfLocationTemplateType {
    Name: string;
    Description?: string;
  }

  export interface CreateShelfLocationTemplateTypeResponse {
    /**
     * Entity type: ShelfLocationTemplateType
     */
    ID: number;
    Error?: EVA.Core.ServiceError;
    Metadata?: EVA.Core.ResponseMessageMetadata;
  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface UpdateShelfLocationTemplateType {
    /**
     * Entity type: ShelfLocationTemplateType
     */
    ID: number;
    Description?: string;
  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface DeleteShelfLocationTemplateType {
    /**
     * Entity type: ShelfLocationTemplateType
     */
    ID: number;
  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface GetShelfLocationTemplateTypes {
  }

  export interface GetShelfLocationTemplateTypesResponse {
    ShelfLocationTemplateTypes: GetShelfLocationTemplateTypesResponse.ShelfLocationTemplateTypeDto[];
    Error?: EVA.Core.ServiceError;
    Metadata?: EVA.Core.ResponseMessageMetadata;
  }

  export namespace GetShelfLocationTemplateTypesResponse {
    export interface ShelfLocationTemplateTypeDto {
      /**
       * Entity type: ShelfLocationTemplateType
       */
      ID: number;
      Name: string;
      Description: string;
    }

  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface GetShelfTypeByID {
    /**
     * Entity type: ShelfType
     */
    ID: number;
  }

  export interface GetShelfTypeByIDResponse {
    ID: number;
    Name: string;
    Description: string;
    Error?: EVA.Core.ServiceError;
    Metadata?: EVA.Core.ResponseMessageMetadata;
  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface CreateShelfType {
    Name: string;
    Description?: string;
  }

  export interface CreateShelfTypeResponse {
    /**
     * Entity type: ShelfType
     */
    ID: number;
    Error?: EVA.Core.ServiceError;
    Metadata?: EVA.Core.ResponseMessageMetadata;
  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface UpdateShelfType {
    /**
     * Entity type: ShelfType
     */
    ID: number;
    Description?: string;
  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface DeleteShelfType {
    /**
     * Entity type: ShelfType
     */
    ID: number;
  }

  /**
   * @deprecated Feature not supported anymore.
   */
  export interface GetShelfTypes {
  }

  export interface GetShelfTypesResponse {
    ShelfTypes: GetShelfTypesResponse.ShelfTypeDto[];
    Error?: EVA.Core.ServiceError;
    Metadata?: EVA.Core.ResponseMessageMetadata;
  }

  export namespace GetShelfTypesResponse {
    export interface ShelfTypeDto {
      /**
       * Entity type: ShelfType
       */
      ID: number;
      Name: string;
      Description: string;
    }

  }

  /**
   * @deprecated Feature not supported anymore.
   * List an aggregated view on shelf products, summing the min- and maximum quantities per Shelf, Organization Unit, Stock Label and Product.
   */
  export interface ListShelfProducts {
    /**
     * Entity type: ProductPropertyType
     */
    IncludedProperties?: string[];
    Query?: string;
    PageConfig?: EVA.Core.PageConfig<ListShelfProductsFilter>;
  }

  export interface ListShelfProductsFilter {
    /**
     * Entity type: OrganizationUnit
     */
    OrganizationUnitID?: number;
    /**
     * Entity type: StockLabel
     */
    StockLabelID?: number;
    BackendID: string;
    /**
     * Entity type: Product
     */
    ProductID?: number;
    /**
     * Entity type: Product
     */
    ProductIDs: number[];
    /**
     * Entity type: Shelf
     */
    ShelfID?: number;
  }

  export interface ListShelfProductsResponse {
    Result?: EVA.Core.PagedResult<ListShelfProductsDto>;
    Error?: EVA.Core.ServiceError;
    Metadata?: EVA.Core.ResponseMessageMetadata;
  }

  export interface ListShelfProductsDto {
    /**
     * Entity type: OrganizationUnit
     */
    OrganizationUnitID: number;
    /**
     * Entity type: StockLabel
     */
    StockLabelID: number;
    StockLabelName: string;
    /**
     * Entity type: Product
     */
    ProductID: number;
    BackendID: string;
    /**
     * Entity type: Shelf
     */
    ShelfID: number;
    ShelfName: string;
    TotalMinimumQuantity: number;
    TotalMaximumQuantity: number;
    Properties: any;
  }

}
