declare module EVA.Vertex {

  export namespace Errors {
    export const enum Vertex {
      /**
       * Did not receive lines from Vertex for document {0:string}
       */
      NoLinesWereReceived = 'Vertex:NoLinesWereReceived',
      /**
       * Vertex error for document {0:string}: {1:string}
       */
      GeneralError = 'Vertex:GeneralError',
      /**
       * Error calling Vertex for document {0:string}: {1:string}
       */
      CallFailure = 'Vertex:CallFailure'
    }

  }


  export interface VertexTaxProviderConfiguration {
    Host: string;
    Username: string;
    Password: string;
    SellerCompany: string;
    CleanseAddress: boolean;
    UseProductGroup: boolean;
    UseMappingHack: boolean;
    UseOriginalTaxCodeWhenExempt: boolean;
    SellerDivision?: string;
    ContainerImage?: VertexContainerImage;
  }

  export interface VertexContainerImage {
    Registry: string;
    Repository: string;
    Tag: string;
    Username: string;
    Password: string;
  }

}
